{$G+,N+,E-}
unit asmz80;{ Z80}
interface
uses Dos,IS18WG93,specproc;
{|}var tics:longint;tics_w:word absolute tics;
procedure closeGraph;
procedure TraceTo(addr_trace:word);
procedure Init;
procedure Done;
procedure set_screen;
function writeF(b:byte):string;
function IntAddr:word;
function reIndex(__index:word;__s:byte):word;
function mem_w(_addr:word):word;
function mem_b(_addr:word):byte;
type t_screen=array[0..$F9FF]of byte;
var EmulScreen:^t_screen;
RealScreen:t_screen absolute $A000:$0000;
var TraceMode,RunMode,DebugMode:boolean;
seg_world,ofs_world:word;
const xGak=30;yGak=4;
type
t_rom=array[0..$3FFF]of byte;
t_memory=array[0..$FFFE]of byte;
t_reg=record F,A,C,B,E,D,L,H:byte end;
t_reg_w=record FA,BC,DE,HL:word end;
t_sp_reg=record I,R:byte;IX,IY,SP,PC:word;end;
t_sp_reg_b=record I,R,IXx,IXi,IYy,IYi,SPp,SPs,PCc,PCp:byte;end;
t_keyboard=array[0..7]of byte;
var
pressHelp,pressExit,err_command:boolean;
Quarz:byte;
memory:^t_memory;
dosRom,sosRom:^t_rom;
keyboard:t_keyboard;
reg,reg_:t_reg;
reg_w:t_reg_w absolute reg;
reg__w:t_reg_w absolute reg_;
sp_reg:t_sp_reg;
sp_reg_b:t_sp_reg_b absolute sp_reg;
Int05Save,Int09Save,Int1CSave:Pointer;
Clock,MaxClock:longint;
kempston,IM,pause:byte;
TheDosMode,NonHalt,MaskInt,NonMaskReady,TimerReady:boolean;
Palette:PaletteType;
implementation
(****************************************************************************)
var InitCode:boolean;
addrUntilCheck:pointer;
CodeJmpNextOp:longint;
const CodeCmpDiAddrTrace=$FF81;CodeJmpEndOp=$07EB;
(****************************************************************************)
{$F+,S-}
procedure NonMaskInt;interrupt;
begin
asm cli end;
NonMaskReady:=true;
asm sti end;
end;

procedure KeyboardInt;interrupt;
var _key:byte;
_my_key:boolean;
begin
if DebugMode then
 begin
  asm
  pushf
  call Int09Save
  end;
  exit;
 end;
asm
in al,$60
mov _key,al
end;
_my_key:=true;
case _key of
$B7:asm int $05 end;
$01:begin pressExit:=true;{Esc}word(addrUntilCheck^):=CodeJmpEndOp;end;
$3B:pressHelp:=true;{F1}
$BB:pressHelp:=false;
$2A:ResBit(0,keyboard[0]);{CS}
$AA:SetBit(0,keyboard[0]);
$2C:ResBit(1,keyboard[0]);{Z}
$AC:SetBit(1,keyboard[0]);
$2D:ResBit(2,keyboard[0]);{X}
$AD:SetBit(2,keyboard[0]);
$2E:ResBit(3,keyboard[0]);{C}
$AE:SetBit(3,keyboard[0]);
$2F:ResBit(4,keyboard[0]);{V}
$AF:SetBit(4,keyboard[0]);
$1E:ResBit(0,keyboard[1]);{A}
$9E:SetBit(0,keyboard[1]);
$1F:ResBit(1,keyboard[1]);{S}
$9F:SetBit(1,keyboard[1]);
$20:ResBit(2,keyboard[1]);{D}
$A0:SetBit(2,keyboard[1]);
$21:ResBit(3,keyboard[1]);{F}
$A1:SetBit(3,keyboard[1]);
$22:ResBit(4,keyboard[1]);{G}
$A2:SetBit(4,keyboard[1]);
$10:ResBit(0,keyboard[2]);{Q}
$90:SetBit(0,keyboard[2]);
$11:ResBit(1,keyboard[2]);{W}
$91:SetBit(1,keyboard[2]);
$12:ResBit(2,keyboard[2]);{E}
$92:SetBit(2,keyboard[2]);
$13:ResBit(3,keyboard[2]);{R}
$93:SetBit(3,keyboard[2]);
$14:ResBit(4,keyboard[2]);{T}
$94:SetBit(4,keyboard[2]);
$02:ResBit(0,keyboard[3]);{1}
$82:SetBit(0,keyboard[3]);
$03:ResBit(1,keyboard[3]);{2}
$83:SetBit(1,keyboard[3]);
$04:ResBit(2,keyboard[3]);{3}
$84:SetBit(2,keyboard[3]);
$05:ResBit(3,keyboard[3]);{4}
$85:SetBit(3,keyboard[3]);
$06:ResBit(4,keyboard[3]);{5}
$86:SetBit(4,keyboard[3]);
$07:ResBit(4,keyboard[4]);{6}
$87:SetBit(4,keyboard[4]);
$08:ResBit(3,keyboard[4]);{7}
$88:SetBit(3,keyboard[4]);
$09:ResBit(2,keyboard[4]);{8}
$89:SetBit(2,keyboard[4]);
$0A:ResBit(1,keyboard[4]);{9}
$8A:SetBit(1,keyboard[4]);
$0B:ResBit(0,keyboard[4]);{0}
$8B:SetBit(0,keyboard[4]);
$15:ResBit(4,keyboard[5]);{Y}
$95:SetBit(4,keyboard[5]);
$16:ResBit(3,keyboard[5]);{U}
$96:SetBit(3,keyboard[5]);
$17:ResBit(2,keyboard[5]);{I}
$97:SetBit(2,keyboard[5]);
$18:ResBit(1,keyboard[5]);{O}
$98:SetBit(1,keyboard[5]);
$19:ResBit(0,keyboard[5]);{P}
$99:SetBit(0,keyboard[5]);
$23:ResBit(4,keyboard[6]);{H}
$A3:SetBit(4,keyboard[6]);
$24:ResBit(3,keyboard[6]);{J}
$A4:SetBit(3,keyboard[6]);
$25:ResBit(2,keyboard[6]);{K}
$A5:SetBit(2,keyboard[6]);
$26:ResBit(1,keyboard[6]);{L}
$A6:SetBit(1,keyboard[6]);
$1C:ResBit(0,keyboard[6]);{EN}
$9C:SetBit(0,keyboard[6]);
$30:ResBit(4,keyboard[7]);{B}
$B0:SetBit(4,keyboard[7]);
$31:ResBit(3,keyboard[7]);{N}
$B1:SetBit(3,keyboard[7]);
$32:ResBit(2,keyboard[7]);{M}
$B2:SetBit(2,keyboard[7]);
$36:ResBit(1,keyboard[7]);{SS}
$B6:SetBit(1,keyboard[7]);
$39:ResBit(0,keyboard[7]);{SP}
$B9:SetBit(0,keyboard[7]);
$4D:SetBit(0,kempston);{Right}
$CD:ResBit(0,kempston);
$4B:SetBit(1,kempston);{Left}
$CB:ResBit(1,kempston);
$50:SetBit(2,kempston);{Down}
$D0:ResBit(2,kempston);
$48:SetBit(3,kempston);{Up}
$C8:ResBit(3,kempston);
$1D:SetBit(4,kempston);{Fire}
$9D:ResBit(4,kempston);
else _my_key:=false;
end;
if not(_my_key)then
asm
pushf
call Int09Save
end else
asm
in al,$61
mov ah,al
or al,$80
out $61,al
xchg ah,al
out $61,al

mov al,$20
out $20,al
end;
end;

procedure TimerHandler;interrupt;
begin
asm cli end;
TimerReady:=true;
asm sti end;
end;
{$F-,S+}
(****************************************************************************)
procedure set_screen;
var _i:integer;
ErrCode: Integer;
begin
asm
mov ax,$0013
int $10
end;
InitPalette;
end;
(****************************************************************************)
procedure set_interrupt;
var _w:word;
begin
GetIntVec($05,Int05Save);
SetIntVec($05,Addr(NonMaskInt));
GetIntVec($09,Int09Save);
SetIntVec($09,Addr(KeyboardInt));{kbr}
GetIntVec($1C,Int1CSave);
SetIntVec($1C,Addr(TimerHandler));
_w:=round(1.19e6/Quarz);
asm
cli
mov al,$36
out $43,al
mov ax,_w
out $40,al
xchg al,ah
out $40,al
sti
end;
end;
(****************************************************************************)
procedure set_keyboard;
var _b:byte;
begin
for _b:=0 to 7 do keyboard[_b]:=$BF;
kempston:=$00;
end;
(****************************************************************************)
procedure reset_interrupt;
begin
SetIntVec($05,Int05Save);
SetIntVec($09,Int09Save);
SetIntVec($1C,Int1CSave);
asm
cli
mov al,$36
out $43,al
xor al,al{18.2}
out $40,al
out $40,al
sti
end;
end;
(****************************************************************************)
procedure my_PutPixel(_x,_y:word;_c:byte);assembler;
asm
mov ax,_y
mov bx,_x
mov cl,_c
 xchg    ah,al
 add     bx,ax
 shr     ax,1
 shr     ax,1
 add     bx,ax
les si,EmulScreen
add si,bx
mov es:[si],cl
cmp traceMode,false
jne @Exit
mov dx,$A000
mov es,dx
mov es:[si],cl
@Exit:
end;
(****************************************************************************)
const recol:array[0..7]of byte=(0,1,4,5,2,3,6,7);
procedure setBorder(_color:byte);
var _c:byte;
begin
_c:=recol[_color];
port[$3C8]:=255;
port[$3C9]:=VGAColors[_c].RedVal;
port[$3C9]:=VGAColors[_c].GreenVal;
port[$3C9]:=VGAColors[_c].BlueVal;
end;
(****************************************************************************)
procedure byte_to_screen(screen_add:word;screen_dat:byte);
function getcol(_c:byte):byte;
var cc:byte;
begin
cc:=recol[_c and $07];
if (_c and $40)<>0 then inc(cc,8);
getcol:=cc;
end;
function getbgr(_c:byte):byte;
begin
getbgr:=recol[(_c and $38)shr 3];
end;
var _x,_y,_i,_j:integer;
_b1,_b2,_bgr,_col,_dat:byte;
_mem_adr:word;
begin
if screen_add<$5800 then
 begin
_b1:=hi(screen_add)and $18;
_b2:=(lo(screen_add)shr 5);
  _y:=(_b1 shl 3)or(_b2 shl 3)or(hi(screen_add)and $07);
  _x:=lo(screen_add)and $1F;
_dat:=memory^[$5800or _x or((_b1 or _b2)shl 5)];
_col:=getcol(_dat);
_bgr:=getbgr(_dat);
_x:=_x shl 3;
  for _i:=0 to 7 do
   if setsBit(7-_i,screen_dat)then my_putpixel(xGak+_x+_i,yGak+_y,_col)else my_putpixel(xGak+_x+_i,yGak+_y,_bgr);
 end else
 begin
_b1:=(hi(screen_add)and $03)shl 3;
_b2:=lo(screen_add);
_y:=(_b1 or((_b2 and $E0)shr 5))shl 3;
_x:=(_b2 and $1F)shl 3;
_col:=getcol(screen_dat);
_bgr:=getbgr(screen_dat);
_mem_adr:=$4000or((_b1 shl 8)or _b2);
  for _j:=0 to 7 do
   begin
   _dat:=memory^[_mem_adr];
   inc(_mem_adr,$0100);
   for _i:=0 to 7 do
    if setsBit(7-_i,_dat)then my_putpixel(xGak+_x+_i,yGak+_y+_j,_col)else my_putpixel(xGak+_x+_i,yGak+_y+_j,_bgr);
   end;
 end;
end;
(****************************************************************************)
procedure write_b(mem_addr:word;mem_dat:byte);
begin
if mem_addr<16384 then exit;
if mem_addr<16384+6912 then if memory^[mem_addr]<>mem_dat then byte_to_screen(mem_addr,mem_dat);
memory^[mem_addr]:=mem_dat;
end;
procedure write_w(mem_addr_w:word;mem_dat_w:word);
begin
write_b(mem_addr_w,lo(mem_dat_w));
write_b(mem_addr_w+1,hi(mem_dat_w));
end;
(****************************************************************************)
function mem_w(_addr:word):word;
begin
mem_w:=$100*memory^[_addr+1]+memory^[_addr]
end;
function mem_b(_addr:word):byte;
begin
mem_b:=memory^[_addr]
end;
(****************************************************************************)
function SetsC:boolean;begin if setsBit(0,reg.F)then SetsC:=true else SetsC:=false;end;
procedure SetC;begin setBit(0,reg.F);end;{७}
procedure ResetC;begin resBit(0,reg.F);end;
procedure SetN;begin setBit(1,reg.F);end;{᫮/⠭}
procedure ResetN;begin resBit(1,reg.F);end;
function SetsPV:boolean;begin if setsBit(2,reg.F)then SetsPV:=true else SetsPV:=false;end;
procedure SetPV;begin setBit(2,reg.F);end;{९/⭮}
procedure ResetPV;begin resBit(2,reg.F);end;

function SetsH:boolean;begin if setsBit(4,reg.F)then SetsH:=true else SetsH:=false;end;
procedure SetH;begin setBit(4,reg.F);end;{㯥७}
procedure ResetH;begin resBit(4,reg.F);end;

function SetsZ:boolean;begin if setsBit(6,reg.F)then SetsZ:=true else SetsZ:=false;end;
procedure SetZ;begin setBit(6,reg.F);end;{}
procedure ResetZ;begin resBit(6,reg.F);end;
function SetsS:boolean;begin if setsBit(7,reg.F)then SetsS:=true else SetsS:=false;end;
procedure SetS;begin setBit(7,reg.F);end;{}
procedure ResetS;begin resBit(7,reg.F);end;
(****************************************************************************)
procedure ChangeZS(_dat:byte);
begin
if _dat=0 then SetZ else ResetZ;
if _dat>=$80 then SetS else ResetS;
end;
procedure ChangeC(_min,_max:word);
begin
if _max<_min then SetC else ResetC;
end;
procedure ChangeV(__to,__add,__result:byte);
begin
if (__to<$80)and(__add<$80)and(__result>=$80)then SetPV else
 if (__to>=$80)and(__add>=$80)and(__result<$80)then SetPV else ResetPV
end;
procedure ChangeP(__result:byte);
var _i,_d:byte;
begin
_d:=0;
for _i:=0 to 7 do if SetsBit(_i,__result)then inc(_d);
if (_d and $01)=0 then SetPV else ResetPV;
end;
procedure Change35(__result:byte);
begin
reg.F:=(reg.F or $28)and($FF-(($FF-__result)and$28));
end;
procedure ChangeH(__to,__add:byte);
begin
if ((__to and $0F)+(__add and $0F))>$0F then SetH else ResetH;
end;
(****************************************************************************)
procedure push(dat:word);
begin
dec(sp_reg.SP,2);
write_w(sp_reg.SP,dat);
end;
(****************************************************************************)
procedure pop(var dat:word);
begin
dat:=mem_w(sp_reg.SP);
inc(sp_reg.SP,2);
end;
(****************************************************************************)
function IntAddr:word;
var mem_addr:word;
begin
case IM of
0,1:IntAddr:=$0038;
2:begin
  mem_addr:=$100*sp_reg.I+$FF;
  IntAddr:=mem_w(mem_addr);
  end;
end;
end;
procedure InterruptZX;
begin
{NonHalt:=true;{??}
if MaskInt then exit;
NonHalt:=true;
push(sp_reg.PC);
sp_reg.PC:=IntAddr;
end;
(****************************************************************************)
procedure timer(takts:byte);
var x:longint;
b:byte;
w:word;
f:file;
begin
if pressHelp then
 begin
reset_interrupt;
assign(f,'help.dat');
reset(f,1);
blockread(f,RealScreen,320*200,w);
close(f);
set_interrupt;
repeat until not(pressHelp);
RealScreen:=EmulScreen^;
 end;
inc(sp_reg.R,takts shr 2);
inc(Clock,takts);
{+প  ஫ ᪮+}
inc(ClockIS18WG93,takts);
if ClockIS18WG93>maxClockIS18WG93{1}then
 begin
  taktIS18WG93;
  dec(ClockIS18WG93,maxClockIS18WG93);
 end;
{++++++++++++++++++++++++++++++++++++}
if Clock>MaxClock then
 begin
  x:=0;
{প  ⠩}  while not(TimerReady)do
   begin
  inc(x);
   end;
(*if not(traceMode)then {RealScreen:=EmulScreen^;}{  Z-}
asm
push es
push ds
push si
mov ax,$A000
mov es,ax
mov di,$0000
mov cx,320*200/4
lds si,EmulScreen;
cld
rep
db $66
movsw
pop si
pop ds
pop es
end;*)
{প  ⠩}  if x>0 then inc(pause)else begin if pause>0 then dec(pause) end;
(* asm{ਢ離  }
 mov dx,$3DA
 @nxt:
 in al,dx
 test al,$08
 jz @nxt
 end;*)
  InterruptZX;
  Clock:=0;
  TimerReady:=false;
 end;
w:=pause*takts;{প  ⠩}
asm
mov cx,w
inc cx
@1:loop @1;
end;
if NonMaskReady then
 begin
 NonMaskReady:=false;
 sp_reg.PC:=$0066;
 end;
end;
(****************************************************************************)
procedure get_mem(_mem:pointer;_osName:string);
var f:file;
begin
assign(f,_osName);
reset(f,1);
blockread(f,_mem^,filesize(f));
close(f);
end;
procedure get_rom;
var w:word;
begin
new(memory);
new(sosRom);
new(dosRom);

get_mem(sosRom,'sos.rom');
get_mem(dosRom,'dos.rom');

for w:=$0 to $FFFF do memory^[w]:=0;
get_mem(memory,'dos.rom'{'sos.rom'{'oc.rom''mugsy.rom'{'demo.rom''zybex.rom'{'art_std.rom'});
TheDosMode:=true;
end;
(****************************************************************************)
procedure addRegN(var _to:byte;_add:byte);
var _result:byte;
begin
_result:=_to+_add;
ChangeZS(_result);
ChangeC(_to,_result);
ChangeV(_to,_add,_result);
Change35(_result);
ChangeH(_to,_add);
ResetN;
_to:=_result;
end;
(****************************************************************************)
procedure incReg(var _to:byte);
var _result:byte;
begin
_result:=_to+1;
ChangeZS(_result);
ChangeV(_to,1,_result);
Change35(_result);
ChangeH(_to,1);
ResetN;
_to:=_result;
end;
(****************************************************************************)
procedure adcRegN(var _to:byte;_add:byte);
var _result,_addd:byte;
_SetsC:boolean;
begin
_addd:=_add;
if SetsC then begin _SetsC:=true;inc(_addd) end else _SetsC:=false;
_result:=_to+_addd;
ChangeZS(_result);
ChangeV(_to,_add,_result);
Change35(_result);
ChangeC(_to,_result);
if (_add=$FF)and _SetsC then SetC;
ChangeH(_to,_addd);
if (((_add and $0F)=$0F)or((_to and $0F)=$0F))and _SetsC then SetH;
ResetN;
_to:=_result;
end;
(****************************************************************************)
procedure decReg(var _to:byte);
var _result:byte;
begin
_result:=_to-1;
ChangeZS(_result);
ChangeV(_result,1,_to);
Change35(_result);
ChangeH(_result,1);
SetN;
_to:=_result;
end;
(****************************************************************************)
procedure subRegN(var _to:byte;_sub:byte);
var _result:byte;
begin
_result:=_to-_sub;
ChangeZS(_result);
ChangeC(_result,_to);
ChangeV(_result,_sub,_to);
Change35(_result);
ChangeH(_result,_sub);
SetN;
_to:=_result;
end;
(****************************************************************************)
procedure sbcRegN(var _to:byte;_sub:byte);
var _result,_subresult:byte;
_SetsC:boolean;
begin
_result:=_to;
if SetsC then _SetsC:=true else _SetsC:=false;
subRegN(_result,_sub);
if _SetsC then
 begin
_subresult:=_result;
dec(_result);
ChangeZS(_result);
Change35(_result);
if not(SetsC)then ChangeC(_result,_subresult);
ChangeV(_result,_sub,_to);
if not(SetsH)then ChangeH(_result,1);
 end;
_to:=_result;
end;
(****************************************************************************)
procedure cpRegN(_to,_cp:byte);
begin
subRegN(_to,_cp);
Change35(_cp);
end;
(****************************************************************************)
procedure ChangeLog(__result:byte);
begin
ChangeZS(__result);
ResetC;
ChangeP(__result);
Change35(__result);
ResetN;
end;
(****************************************************************************)
procedure andRegN(var _to:byte;_and:byte);
var _result:byte;
begin
_result:=_to and _and;
ChangeLog(_result);
SetH;
_to:=_result;
end;
(****************************************************************************)
procedure orRegN(var _to:byte;_and:byte);
var _result:byte;
begin
_result:=_to or _and;
ChangeLog(_result);
ResetH;
_to:=_result;
end;
(****************************************************************************)
procedure xorRegN(var _to:byte;_and:byte);
var _result:byte;
begin
_result:=_to xor _and;
ChangeLog(_result);
ResetH;
_to:=_result;
end;
(****************************************************************************)
function reIndex(__index:word;__s:byte):word;
begin
if __s>=$80 then reIndex:=__index-($100-__s) else reIndex:=__index+__s;
end;
(****************************************************************************)
procedure jr(_sAdr:byte);
begin
if _sAdr>=$80 then dec(sp_reg.PC,$100-_sAdr) else inc(sp_reg.PC,_sAdr);
end;
(****************************************************************************)
procedure Change35HN(_result:byte);
begin
Change35(_result);
ResetN;
ResetH;
end;
procedure ChangeZS35PHN(__result:byte);
begin
ChangeZS(__result);
ChangeP(__result);
Change35HN(__result);
end;
(****************************************************************************)
procedure srl(var _dat:byte);
var _b:byte;
begin
_b:=_dat;
if setsBit(0,_b) then SetC else ResetC;
_b:=_b shr 1;
_dat:=_b;
end;
(****************************************************************************)
procedure sra(var _dat:byte);
var _b:byte;
begin
_b:=_dat;
if setsBit(0,_b) then SetC else ResetC;
_b:=_b shr 1;
if setsBit(6,_b) then setBit(7,_b) else resBit(7,_b);
_dat:=_b;
end;
(****************************************************************************)
procedure sla(var _dat:byte);
var _b:byte;
begin
_b:=_dat;
if setsBit(7,_b) then SetC else ResetC;
_b:=_b shl 1;
_dat:=_b;
end;
(****************************************************************************)
procedure rl(var _dat:byte);
var _b:byte;
_SetsC:boolean;
begin
_b:=_dat;
if SetsC then _SetsC:=true else _SetsC:=false;
if setsBit(7,_b) then SetC else ResetC;
_b:=_b shl 1;
if _SetsC then setBit(0,_b) else resBit(0,_b);
_dat:=_b;
end;
(****************************************************************************)
procedure rr(var _dat:byte);
var _b:byte;
_SetsC:boolean;
begin
_b:=_dat;
if SetsC then _SetsC:=true else _SetsC:=false;
if setsBit(0,_b) then SetC else ResetC;
_b:=_b shr 1;
if _SetsC then setBit(7,_b) else resBit(7,_b);
_dat:=_b;
end;
(****************************************************************************)
procedure rlc(var _dat:byte);
var _b:byte;
begin
_b:=_dat;
if setsBit(7,_b) then SetC else ResetC;
asm
mov al,_b
rol al,1
mov _b,al
end;
ResetH;
ResetN;
Change35(_b);
_dat:=_b;
end;
(****************************************************************************)
procedure rrc(var _dat:byte);
var _b:byte;
begin
_b:=_dat;
if setsBit(0,_b) then SetC else ResetC;
asm
mov al,_b
ror al,1
mov _b,al
end;
_dat:=_b;
end;
(****************************************************************************)
procedure bitBit(_bitNum,_byte:byte);
begin
if setsBit(_bitNum,_byte) then begin ResetPV;ResetZ end else begin SetPV;SetZ end;
Change35(_byte);
ResetS;
SetH;
ResetN;
end;
(****************************************************************************)
function writeB(_dt:byte):string;forward;

procedure writedebug(_str:string;_a0,_a8,_b:byte);
var f:text;
begin
assign(f,'debug.tmp');
append(f);
writeln(f,_str,writeB(_a0),' ',writeB(_a8),' ',writeB(_b),' ',
writeB(hi(sp_reg.pc-1)),writeB(lo(sp_reg.pc-1)));
close(f);
end;

procedure inDat(_a0a7,_a8a15:byte;var _dat:byte);
var _b,_i:byte;
s_dat:string;
begin
_dat:=0;
{if TheDosMode then
writeDebug('inDos:',_a0a7,_a8a15,_dat) else
writeDebug('inSos:',_a0a7,_a8a15,_dat)};
if TheDosMode then{  1818  93}
 begin
_dat:=inDatIS18WG93(_a0a7);
 exit;
 end;
 case _a0a7 of
$FE:begin
  case _a8a15 of
  $00,$E7:begin
  _b:=$FF;
  for _i:=0 to 7 do _b:=_b and keyboard[_i];
  _dat:=_b;
      end;
  $FE:_dat:=keyboard[0];
  $FD:_dat:=keyboard[1];
  $FB:_dat:=keyboard[2];
  $F7:_dat:=keyboard[3];
  $EF:_dat:=keyboard[4];
  $DF:_dat:=keyboard[5];
  $BF:_dat:=keyboard[6];
  $7F:_dat:=keyboard[7];
  else
  begin
{  err_command:=true;}
  end;
  end;
  ResBit(6,_dat);{EAR}
    end;
$1F:_dat:=kempston;
$FC:_dat:=191;
else
begin
{err_command:=true;}
end;
end
end;
(****************************************************************************)
procedure outDat(_a0a7,_a8a15,_dat:byte);
var _bb:byte;
begin
{if TheDosMode then
writeDebug('otDos:',_a0a7,_a8a15,_dat) else
writeDebug('otSos:',_a0a7,_a8a15,_dat)};

if TheDosMode then{  1818  93}
 begin
outDatIS18WG93(_a0a7,_dat);
 exit;
 end;

case _a0a7 of
$FE:begin
 if setsBit(4,_dat){ xor setsBit(3,_dat) }then{speacker | MIC}
  asm
   in al,$61;
   and al,not 1;
   or al,2;
   out $61,al
  end else
  asm
   in al,$61;
   and al,not 1;
   and al,not 2;
   out $61,al
  end;
 setBorder(_dat and $07);
    end;
$7F:begin end;
$5F:begin end;
else
begin
{err_command:=true;}
end;
end;
end;
(****************************************************************************)
procedure _LDRegN(var b:byte);
begin
inc(sp_reg.PC);
b:=mem_b(sp_reg.PC);
inc(sp_reg.PC);
timer(7);
end;
(****************************************************************************)
procedure _LDRegNN(var w:word;time:word);
begin
inc(sp_reg.PC);
w:=mem_w(sp_reg.PC);
inc(sp_reg.PC,2);
timer(time);
end;
(****************************************************************************)
procedure _LDRegReg(var _to:byte;_from:byte);
begin
_to:=_from;
inc(sp_reg.PC);
timer(4);
end;
(****************************************************************************)
procedure _LDfromIR(_from:byte);
begin
reg.A:=_from;
inc(sp_reg.PC);
if MaskInt then ResetPV else SetPV;
ChangeZS(_from);
timer(9);
end;
(****************************************************************************)
procedure _LDtoIR(var _to:byte);
begin
_to:=reg.A;
inc(sp_reg.PC);
timer(9);
end;
(****************************************************************************)
procedure _LDRpRp(var _to:word;_from:word;time:byte);
begin
_to:=_from;
inc(sp_reg.PC,1);
timer(time);
end;
(****************************************************************************)
procedure _LDRpAdr(var _to:word;time:byte);
var _w:word;
begin
inc(sp_reg.PC);
_w:=mem_w(sp_reg.PC);
_to:=mem_w(_w);
inc(sp_reg.PC,2);
timer(time);
end;
(****************************************************************************)
procedure _LDRegAdr(var _to:byte;time:byte);
var _w:word;
begin
inc(sp_reg.PC);
_w:=mem_w(sp_reg.PC);
_to:=mem_b(_w);
inc(sp_reg.PC,2);
timer(time);
end;
(****************************************************************************)
procedure _LDRegArp(var _to:byte;_adr:word);
begin
_to:=mem_b(_adr);
inc(sp_reg.PC);
timer(7);
end;
(****************************************************************************)
procedure _LDRegIdx(var _to:byte;_Index:word);
begin
inc(sp_reg.PC);
_to:=mem_b(reIndex(_Index,mem_b(sp_reg.PC)));
inc(sp_reg.PC);
timer(19);
end;
(****************************************************************************)
procedure _EXRpRp(var _a,_b:word);
var _w:word;
begin
_w:=_a;
_a:=_b;
_b:=_w;
inc(sp_reg.PC);
timer(4);
end;
(****************************************************************************)
procedure _EXX;
var reg_tmp:t_reg;
proba:word;
begin
reg_tmp:=reg;
reg:=reg_;
reg_:=reg_tmp;

proba:=reg__w.FA;
reg__w.FA:=reg_w.FA;
reg_w.FA:=proba;

inc(sp_reg.PC);
timer(4);
end;
(****************************************************************************)
procedure _LDAdrReg(_dat:byte;time:byte);
var _w:word;
begin
inc(sp_reg.PC);
_w:=mem_w(sp_reg.PC);
write_b(_w,_dat);
inc(sp_reg.PC,2);
timer(time);
end;
(****************************************************************************)
procedure _LDAdrRp(_dat:word;time:byte);
var _w:word;
begin
inc(sp_reg.PC);
_w:=mem_w(sp_reg.PC);
write_w(_w,_dat);
inc(sp_reg.PC,2);
timer(time);
end;
(****************************************************************************)
procedure _LDArpReg(_adr:word;_dat:byte);
begin
write_b(_adr,_dat);
inc(sp_reg.PC);
timer(7);
end;
(****************************************************************************)
procedure _LDArpN(_adr:word);
begin
inc(sp_reg.PC);
write_b(_adr,mem_b(sp_reg.PC));
inc(sp_reg.PC);
timer(10);
end;
(****************************************************************************)
procedure _LDIdxReg(_Index:word;_dat:byte);
begin
inc(sp_reg.PC);
write_b(reIndex(_Index,mem_b(sp_reg.PC)),_dat);
inc(sp_reg.PC);
timer(19);
end;
(****************************************************************************)
procedure _LDIdxN(_Index:word);
var _adr:word;
begin
inc(sp_reg.PC);
_adr:=reIndex(_Index,mem_b(sp_reg.PC));
inc(sp_reg.PC);
write_b(_adr,mem_b(sp_reg.PC));
inc(sp_reg.PC);
timer(19);
end;
(****************************************************************************)
procedure _ADDRegAN;
begin
inc(sp_reg.PC);
addRegN(reg.A,mem_b(sp_reg.PC));
inc(sp_reg.PC);
timer(7);
end;
(****************************************************************************)
procedure _ADDRegAReg(_reg:byte);
begin
addRegN(reg.A,_reg);
inc(sp_reg.PC);
timer(4);
end;
(****************************************************************************)
procedure _ADDRegAArp(_adr:word);
begin
addRegN(reg.A,mem_b(_adr));
inc(sp_reg.PC);
timer(7);
end;
(****************************************************************************)
procedure _ADDRegAIdx(_Index:word);
begin
inc(sp_reg.PC);
addRegN(reg.A,mem_b(reIndex(_Index,mem_b(sp_reg.PC))));
inc(sp_reg.PC);
timer(19);
end;
(****************************************************************************)
procedure _ADDRpRp(var _to:word;_add:word;time:byte);
var _result:word;
begin
_result:=_to+_add;
ChangeC(_to,_result);
ResetN;
Change35(hi(_result));
{ChangeH(hi(_to),hi(lo(_to)+lo(_add)));???}
_to:=_result;
inc(sp_reg.PC);
timer(time);
end;
(****************************************************************************)
procedure _INCReg(var _reg:byte);
var _result:byte;
begin
incReg(_reg);
inc(sp_reg.PC);
timer(4);
end;
(****************************************************************************)
procedure _INCArp(_adr:word);
var _dat:byte;
begin
_dat:=mem_b(_adr);
incReg(_dat);
write_b(_adr,_dat);
inc(sp_reg.PC);
timer(11);
end;
(****************************************************************************)
procedure _INCAIdx(_Index:word);
var _dat:byte;
_adr:word;
begin
inc(sp_reg.PC);
_adr:=reIndex(_Index,mem_b(sp_reg.PC));
_dat:=mem_b(_adr);
incReg(_dat);
write_b(_adr,_dat);
inc(sp_reg.PC);
timer(23);
end;
(****************************************************************************)
procedure _INCRp(var _dat:word;time:byte);
begin
inc(_dat);
inc(sp_reg.PC);
timer(time);
end;
(****************************************************************************)
procedure _ADCRegAN;
begin
inc(sp_reg.PC);
adcRegN(reg.A,mem_b(sp_reg.PC));
inc(sp_reg.PC);
timer(7);
end;
(****************************************************************************)
procedure _ADCRegAReg(_reg:byte);
begin
adcRegN(reg.A,_reg);
inc(sp_reg.PC);
timer(4);
end;
(****************************************************************************)
procedure _ADCRegAArp(_adr:word);
begin
adcRegN(reg.A,mem_b(_adr));
inc(sp_reg.PC);
timer(7);
end;
(****************************************************************************)
procedure _ADCRegAIdx(_Index:word);
begin
inc(sp_reg.PC);
adcRegN(reg.A,mem_b(reIndex(_Index,mem_b(sp_reg.PC))));
inc(sp_reg.PC);
timer(19);
end;
(****************************************************************************)
procedure _ADCHlRp(_reg:word);
begin
adcRegN(reg.L,lo(_reg));
adcRegN(reg.H,hi(_reg));
if reg_w.HL=0 then SetZ else ResetZ;
inc(sp_reg.PC);
timer(15);
end;
(****************************************************************************)
procedure _SUBRegAN;
begin
inc(sp_reg.PC);
subRegN(reg.A,mem_b(sp_reg.PC));
inc(sp_reg.PC);
timer(7);
end;
(****************************************************************************)
procedure _SUBRegAReg(_reg:byte);
begin
subRegN(reg.A,_reg);
inc(sp_reg.PC);
timer(4);
end;
(****************************************************************************)
procedure _SUBRegAArp(_adr:word);
begin
subRegN(reg.A,mem_b(_adr));
inc(sp_reg.PC);
timer(7);
end;
(****************************************************************************)
procedure _SUBRegAIdx(_Index:word);
begin
inc(sp_reg.PC);
subRegN(reg.A,mem_b(reIndex(_Index,mem_b(sp_reg.PC))));
inc(sp_reg.PC);
timer(19);
end;
(****************************************************************************)
procedure _DECReg(var _reg:byte);
begin
decReg(_reg);
inc(sp_reg.PC);
timer(4);
end;
(****************************************************************************)
procedure _DECArp(_adr:word);
var _dat:byte;
begin
_dat:=mem_b(_adr);
decReg(_dat);
write_b(_adr,_dat);
inc(sp_reg.PC);
timer(11);
end;
(****************************************************************************)
procedure _DECAIdx(_Index:word);
var _dat:byte;
_adr:word;
begin
inc(sp_reg.PC);
_adr:=reIndex(_Index,mem_b(sp_reg.PC));
_dat:=mem_b(_adr);
decReg(_dat);
write_b(_adr,_dat);
inc(sp_reg.PC);
timer(23);
end;
(****************************************************************************)
procedure _DECRp(var _dat:word;time:byte);
begin
dec(_dat);
inc(sp_reg.PC);
timer(time);
end;
(****************************************************************************)
procedure _SBCRegAN;
begin
inc(sp_reg.PC);
sbcRegN(reg.A,mem_b(sp_reg.PC));
inc(sp_reg.PC);
timer(7);
end;
(****************************************************************************)
procedure _SBCRegAReg(_reg:byte);
begin
sbcRegN(reg.A,_reg);
inc(sp_reg.PC);
timer(4);
end;
(****************************************************************************)
procedure _SBCRegAArp(_adr:word);
begin
sbcRegN(reg.A,mem_b(_adr));
inc(sp_reg.PC);
timer(7);
end;
(****************************************************************************)
procedure _SBCRegAIdx(_Index:word);
begin
inc(sp_reg.PC);
sbcRegN(reg.A,mem_b(reIndex(_Index,mem_b(sp_reg.PC))));
inc(sp_reg.PC);
timer(19);
end;
(****************************************************************************)
procedure _SBCHlRp(_reg:word);
begin
sbcRegN(reg.L,lo(_reg));
sbcRegN(reg.H,hi(_reg));
if reg_w.HL=0 then SetZ else ResetZ;
inc(sp_reg.PC);
timer(15);
end;
(****************************************************************************)
procedure _CPRegAN;
begin
inc(sp_reg.PC);
cpRegN(reg.A,mem_b(sp_reg.PC));
inc(sp_reg.PC);
timer(7);
end;
(****************************************************************************)
procedure _CPRegAReg(_reg:byte);
begin
cpRegN(reg.A,_reg);
inc(sp_reg.PC);
timer(4);
end;
(****************************************************************************)
procedure _CPRegAArp(_adr:word);
begin
cpRegN(reg.A,mem_b(_adr));
inc(sp_reg.PC);
timer(7);
end;
(****************************************************************************)
procedure _CPRegAIdx(_Index:word);
begin
inc(sp_reg.PC);
cpRegN(reg.A,mem_b(reIndex(_Index,mem_b(sp_reg.PC))));
inc(sp_reg.PC);
timer(19);
end;
(****************************************************************************)
procedure _ANDRegAN;
begin
inc(sp_reg.PC);
andRegN(reg.A,mem_b(sp_reg.PC));
inc(sp_reg.PC);
timer(7);
end;
(****************************************************************************)
procedure _ANDRegAReg(_reg:byte);
begin
andRegN(reg.A,_reg);
inc(sp_reg.PC);
timer(4);
end;
(****************************************************************************)
procedure _ANDRegAArp(_adr:word);
begin
andRegN(reg.A,mem_b(_adr));
inc(sp_reg.PC);
timer(7);
end;
(****************************************************************************)
procedure _ANDRegAIdx(_Index:word);
begin
inc(sp_reg.PC);
andRegN(reg.A,mem_b(reIndex(_Index,mem_b(sp_reg.PC))));
inc(sp_reg.PC);
timer(19);
end;
(****************************************************************************)
procedure _ORRegAN;
begin
inc(sp_reg.PC);
orRegN(reg.A,mem_b(sp_reg.PC));
inc(sp_reg.PC);
timer(7);
end;
(****************************************************************************)
procedure _ORRegAReg(_reg:byte);
begin
orRegN(reg.A,_reg);
inc(sp_reg.PC);
timer(4);
end;
(****************************************************************************)
procedure _ORRegAArp(_adr:word);
begin
orRegN(reg.A,mem_b(_adr));
inc(sp_reg.PC);
timer(7);
end;
(****************************************************************************)
procedure _ORRegAIdx(_Index:word);
begin
inc(sp_reg.PC);
orRegN(reg.A,mem_b(reIndex(_Index,mem_b(sp_reg.PC))));
inc(sp_reg.PC);
timer(19);
end;
(****************************************************************************)
procedure _XORRegAN;
begin
inc(sp_reg.PC);
xorRegN(reg.A,mem_b(sp_reg.PC));
inc(sp_reg.PC);
timer(7);
end;
(****************************************************************************)
procedure _XORRegAReg(_reg:byte);
begin
xorRegN(reg.A,_reg);
inc(sp_reg.PC);
timer(4);
end;
(****************************************************************************)
procedure _XORRegAArp(_adr:word);
begin
xorRegN(reg.A,mem_b(_adr));
inc(sp_reg.PC);
timer(7);
end;
(****************************************************************************)
procedure _XORRegAIdx(_Index:word);
begin
inc(sp_reg.PC);
xorRegN(reg.A,mem_b(reIndex(_Index,mem_b(sp_reg.PC))));
inc(sp_reg.PC);
timer(19);
end;
(****************************************************************************)
procedure _JPNN;
begin
inc(sp_reg.PC);
sp_reg.PC:=mem_w(sp_reg.PC);
timer(10);
end;
(****************************************************************************)
procedure _JPArp(_adr:word;time:byte);
begin
sp_reg.PC:=_adr;
timer(time);
end;
(****************************************************************************)
procedure _JPNNif(_if:boolean);
begin
inc(sp_reg.PC);
if _if then sp_reg.PC:=mem_w(sp_reg.PC) else inc(sp_reg.PC,2);
timer(10);
end;
(****************************************************************************)
procedure _JRS;
var _b:byte;
begin
inc(sp_reg.PC);
_b:=mem_b(sp_reg.PC);
inc(sp_reg.PC);
jr(_b);
timer(7);
end;
(****************************************************************************)
procedure _JRSif(_if:boolean);
var _b:byte;
begin
inc(sp_reg.PC);
_b:=mem_b(sp_reg.PC);
inc(sp_reg.PC);
if _if then
 begin
 jr(_b);
 timer(12);
 end else timer(7);
end;
(****************************************************************************)
procedure _DJNZ;
var _b:byte;
begin
dec(reg.B);
inc(sp_reg.PC);
_b:=mem_b(sp_reg.PC);
inc(sp_reg.PC);
if reg.B<>0 then
 begin
 jr(_b);
 timer(13);
 end else timer(8);
end;
(****************************************************************************)
procedure _PUSH(w,time:word);
begin
push(w);
inc(sp_reg.PC);
timer(time);
end;
(****************************************************************************)
procedure _POP(var w:word;time:word);
begin
pop(w);
inc(sp_reg.PC);
timer(time);
end;
(****************************************************************************)
procedure _EXsp(var _dat:word;time:word);
var _w:word;
begin
pop(_w);
push(_dat);
_dat:=_w;
inc(sp_reg.PC);
timer(time);
end;
(****************************************************************************)
procedure _RST(_adr:word);
begin
inc(sp_reg.PC);
push(sp_reg.PC);
sp_reg.PC:=_adr;
timer(11);
end;
(****************************************************************************)
procedure _CALL;
var _adr:word;
begin
inc(sp_reg.PC);
_adr:=mem_w(sp_reg.PC);
inc(sp_reg.PC,2);
push(sp_reg.PC);
sp_reg.PC:=_adr;
timer(17);
end;
(****************************************************************************)
procedure _CALLif(_if:boolean);
var _adr:word;
begin
inc(sp_reg.PC);
_adr:=mem_w(sp_reg.PC);
inc(sp_reg.PC,2);
if _if then
 begin
 push(sp_reg.PC);
 sp_reg.PC:=_adr;
 timer(17);
 end else timer(10);
end;
(****************************************************************************)
procedure _RET;
begin
pop(sp_reg.PC);
timer(10);
end;
(****************************************************************************)
procedure _RETif(_if:boolean);
var _adr:word;
begin
inc(sp_reg.PC);
if _if then
 begin
 pop(sp_reg.PC);
 timer(11);
 end else timer(5);
end;
(****************************************************************************)
procedure _SRLReg(var _dat:byte);
var _b:byte;
begin
_b:=_dat;
srl(_b);
ChangeZS35PHN(_b);
_dat:=_b;
inc(sp_reg.PC);
timer(8);
end;
(****************************************************************************)
procedure _SRLArp(_adr:word);
var _b:byte;
begin
_b:=mem_b(_adr);
srl(_b);
ChangeZS35PHN(_b);
write_b(_adr,_b);
inc(sp_reg.PC);
timer(15);
end;
(****************************************************************************)
procedure _SRLIdx(_Index:word);
var _b:byte;
_adr:word;
begin
_adr:=reIndex(_Index,mem_b(sp_reg.PC-1));
_b:=mem_b(_adr);
srl(_b);
ChangeZS35PHN(_b);
write_b(_adr,_b);
inc(sp_reg.PC);
timer(23);
end;
(****************************************************************************)
procedure _SRAReg(var _dat:byte);
var _b:byte;
begin
_b:=_dat;
sra(_b);
ChangeZS35PHN(_b);
_dat:=_b;
inc(sp_reg.PC);
timer(8);
end;
(****************************************************************************)
procedure _SRAArp(_adr:word);
var _b:byte;
begin
_b:=mem_b(_adr);
sra(_b);
ChangeZS35PHN(_b);
write_b(_adr,_b);
inc(sp_reg.PC);
timer(15);
end;
(****************************************************************************)
procedure _SRAIdx(_Index:word);
var _b:byte;
_adr:word;
begin
_adr:=reIndex(_Index,mem_b(sp_reg.PC-1));
_b:=mem_b(_adr);
sra(_b);
ChangeZS35PHN(_b);
write_b(_adr,_b);
inc(sp_reg.PC);
timer(23);
end;
(****************************************************************************)
procedure _SLAReg(var _dat:byte);
var _b:byte;
begin
_b:=_dat;
sla(_b);
ChangeZS35PHN(_b);
_dat:=_b;
inc(sp_reg.PC);
timer(8);
end;
(****************************************************************************)
procedure _SLAArp(_adr:word);
var _b:byte;
begin
_b:=mem_b(_adr);
sla(_b);
ChangeZS35PHN(_b);
write_b(_adr,_b);
inc(sp_reg.PC);
timer(15);
end;
(****************************************************************************)
procedure _SLAIdx(_Index:word);
var _b:byte;
_adr:word;
begin
_adr:=reIndex(_Index,mem_b(sp_reg.PC-1));
_b:=mem_b(_adr);
sla(_b);
ChangeZS35PHN(_b);
write_b(_adr,_b);
inc(sp_reg.PC);
timer(23);
end;
(****************************************************************************)
procedure _RLReg(var _dat:byte);
var _b:byte;
begin
_b:=_dat;
rl(_b);
ChangeZS35PHN(_b);
_dat:=_b;
inc(sp_reg.PC);
timer(8);
end;
(****************************************************************************)
procedure _RLArp(_adr:word);
var _b:byte;
begin
_b:=mem_b(_adr);
rl(_b);
ChangeZS35PHN(_b);
write_b(_adr,_b);
inc(sp_reg.PC);
timer(15);
end;
(****************************************************************************)
procedure _RLIdx(_Index:word);
var _b:byte;
_adr:word;
begin
_adr:=reIndex(_Index,mem_b(sp_reg.PC-1));
_b:=mem_b(_adr);
rl(_b);
ChangeZS35PHN(_b);
write_b(_adr,_b);
inc(sp_reg.PC);
timer(23);
end;
(****************************************************************************)
procedure _RRReg(var _dat:byte);
var _b:byte;
begin
_b:=_dat;
rr(_b);
ChangeZS35PHN(_b);
_dat:=_b;
inc(sp_reg.PC);
timer(8);
end;
(****************************************************************************)
procedure _RRArp(_adr:word);
var _b:byte;
begin
_b:=mem_b(_adr);
rr(_b);
ChangeZS35PHN(_b);
write_b(_adr,_b);
inc(sp_reg.PC);
timer(15);
end;
(****************************************************************************)
procedure _RRIdx(_Index:word);
var _b:byte;
_adr:word;
begin
_adr:=reIndex(_Index,mem_b(sp_reg.PC-1));
_b:=mem_b(_adr);
rr(_b);
ChangeZS35PHN(_b);
write_b(_adr,_b);
inc(sp_reg.PC);
timer(23);
end;
(****************************************************************************)
procedure _RLCReg(var _dat:byte);
var _b:byte;
begin
_b:=_dat;
rlc(_b);
ChangeZS35PHN(_b);
_dat:=_b;
inc(sp_reg.PC);
timer(8);
end;
(****************************************************************************)
procedure _RLCArp(_adr:word);
var _b:byte;
begin
_b:=mem_b(_adr);
rlc(_b);
ChangeZS35PHN(_b);
write_b(_adr,_b);
inc(sp_reg.PC);
timer(15);
end;
(****************************************************************************)
procedure _RLCIdx(_Index:word);
var _b:byte;
_adr:word;
begin
_adr:=reIndex(_Index,mem_b(sp_reg.PC-1));
_b:=mem_b(_adr);
rlc(_b);
ChangeZS35PHN(_b);
write_b(_adr,_b);
inc(sp_reg.PC);
timer(23);
end;
(****************************************************************************)
procedure _RRCReg(var _dat:byte);
var _b:byte;
begin
_b:=_dat;
rrc(_b);
ChangeZS35PHN(_b);
_dat:=_b;
inc(sp_reg.PC);
timer(8);
end;
(****************************************************************************)
procedure _RRCArp(_adr:word);
var _b:byte;
begin
_b:=mem_b(_adr);
rrc(_b);
ChangeZS35PHN(_b);
write_b(_adr,_b);
inc(sp_reg.PC);
timer(15);
end;
(****************************************************************************)
procedure _RRCIdx(_Index:word);
var _b:byte;
_adr:word;
begin
_adr:=reIndex(_Index,mem_b(sp_reg.PC-1));
_b:=mem_b(_adr);
rrc(_b);
ChangeZS35PHN(_b);
write_b(_adr,_b);
inc(sp_reg.PC);
timer(23);
end;
(****************************************************************************)
procedure _RLA;
begin
rl(reg.A);
Change35HN(reg.A);
inc(sp_reg.PC);
timer(4);
end;
(****************************************************************************)
procedure _RRA;
begin
rr(reg.A);
Change35HN(reg.A);
inc(sp_reg.PC);
timer(4);
end;
(****************************************************************************)
procedure _RLCA;
begin
rlc(reg.A);
Change35HN(reg.A);
inc(sp_reg.PC);
timer(4);
end;
(****************************************************************************)
procedure _RRCA;
begin
rrc(reg.A);
Change35HN(reg.A);
inc(sp_reg.PC);
timer(4);
end;
(****************************************************************************)
procedure _SET(_bit:byte;var _to:byte);
begin
setBit(_bit,_to);
inc(sp_reg.PC);
timer(8);
end;
(****************************************************************************)
procedure _SEThl(_bit:byte);
var _b:byte;
begin
_b:=mem_b(reg_w.HL);
setBit(_bit,_b);
write_b(reg_w.HL,_b);
inc(sp_reg.PC);
timer(15);
end;
(****************************************************************************)
procedure _SETix(_bit:byte;_Index:word);
var _b:byte;
_adr:word;
begin
_adr:=reIndex(_Index,mem_b(sp_reg.PC-1));
_b:=mem_b(_adr);
setBit(_bit,_b);
write_b(_adr,_b);
inc(sp_reg.PC);
timer(23);
end;
(****************************************************************************)
procedure _RES(_bit:byte;var _to:byte);
begin
resBit(_bit,_to);
inc(sp_reg.PC);
timer(8);
end;
(****************************************************************************)
procedure _REShl(_bit:byte);
var _b:byte;
begin
_b:=mem_b(reg_w.HL);
resBit(_bit,_b);
write_b(reg_w.HL,_b);
inc(sp_reg.PC);
timer(15);
end;
(****************************************************************************)
procedure _RESix(_bit:byte;_Index:word);
var _b:byte;
_adr:word;
begin
_adr:=reIndex(_Index,mem_b(sp_reg.PC-1));
_b:=mem_b(_adr);
resBit(_bit,_b);
write_b(_adr,_b);
inc(sp_reg.PC);
timer(23);
end;
(****************************************************************************)
procedure _BIT(_bits:byte;var _to:byte);
begin
bitBit(_bits,_to);
inc(sp_reg.PC);
timer(8);
end;
(****************************************************************************)
procedure _BIThl(_bit:byte);
begin
bitBit(_bit,mem_b(reg_w.HL));
inc(sp_reg.PC);
timer(12);
end;
(****************************************************************************)
procedure _BITix(_bit:byte;_Index:word);
begin
bitBit(_bit,mem_b(reIndex(_Index,mem_b(sp_reg.PC-1))));
inc(sp_reg.PC);
timer(20);
end;
(****************************************************************************)
procedure _LDIR;
var oldMask:boolean;
begin
{!}oldMask:=MaskInt;
{!}MaskInt:=true;
SetPV;
inc(sp_reg.PC);
repeat
write_b(reg_w.DE,mem_b(reg_w.HL));
inc(reg_w.HL);
inc(reg_w.DE);
dec(reg_w.BC);
timer(21);
until reg_w.BC=0;
ResetPV;
timer(16);
{!}MaskInt:=oldMask;
end;
(****************************************************************************)
procedure _LDDR;
var oldMask:boolean;
begin
{!}oldMask:=MaskInt;
{!}MaskInt:=true;
SetPV;
inc(sp_reg.PC);
repeat
write_b(reg_w.DE,mem_b(reg_w.HL));
dec(reg_w.HL);
dec(reg_w.DE);
dec(reg_w.BC);
timer(21);
until reg_w.BC=0;
ResetPV;
timer(16);
{!}MaskInt:=oldMask;
end;
(****************************************************************************)
procedure _LDI;
begin
write_b(reg_w.DE,mem_b(reg_w.HL));
inc(reg_w.HL);
inc(reg_w.DE);
dec(reg_w.BC);
if reg_w.BC=0 then ResetPV else SetPV;
inc(sp_reg.PC);
timer(16);
end;
(****************************************************************************)
procedure _LDD;
begin
write_b(reg_w.DE,mem_b(reg_w.HL));
dec(reg_w.HL);
dec(reg_w.DE);
dec(reg_w.BC);
if reg_w.BC=0 then ResetPV else SetPV;
inc(sp_reg.PC);
timer(16);
end;
(****************************************************************************)
procedure _CPIR;
begin
SetPV;
ResetZ;
SetS;
inc(sp_reg.PC);
repeat
dec(reg_w.BC);
if reg.A=mem_b(reg_w.HL) then
 begin
 SetZ;
 ResetS;
 break;
 end;
inc(reg_w.HL);
if reg_w.BC=0 then
 begin
 ResetPV;
 timer(16);
 break;
 end else timer(21);
until false;
end;
(****************************************************************************)
procedure _CPDR;
begin
SetPV;
ResetZ;
SetS;
inc(sp_reg.PC);
repeat
dec(reg_w.BC);
if reg.A=mem_b(reg_w.HL) then
 begin
 SetZ;
 ResetS;
 break;
 end;
dec(reg_w.HL);
if reg_w.BC=0 then
 begin
 ResetPV;
 timer(16);
 break;
 end else timer(21);
until false;
end;
(****************************************************************************)
procedure _CPI;
begin
dec(reg_w.BC);
if reg.A=mem_b(reg_w.HL) then SetZ else
 begin
 ResetZ;
 inc(reg_w.HL);
 end;
if reg_w.BC=0 then ResetPV else SetPV;
inc(sp_reg.PC);
timer(16);
end;
(****************************************************************************)
procedure _CPD;
begin
dec(reg_w.BC);
if reg.A=mem_b(reg_w.HL) then SetZ else
 begin
 ResetZ;
 dec(reg_w.HL);
 end;
if reg_w.BC=0 then ResetPV else SetPV;
inc(sp_reg.PC);
timer(16);
end;
(****************************************************************************)
procedure _INRegAN;
begin
inc(sp_reg.PC);
inDat(mem_b(sp_reg.PC),reg.A,reg.A);
inc(sp_reg.PC);
timer(11);
end;
(****************************************************************************)
procedure _INRegC(var _dat:byte);
var _b:byte;
begin
inDat(reg.C,reg.B,_b);
ChangeZS(_b);
ChangeP(_b);
Change35(_b);
_dat:=_b;
inc(sp_reg.PC);
timer(12);
end;
(****************************************************************************)
procedure _INI;
var _b:byte;
begin
inDat(reg.C,reg.B,_b);
write_b(reg_w.HL,_b);
inc(reg_w.HL);
dec(reg.B);
ChangeZS(reg.B);
inc(sp_reg.PC);
timer(16);
end;
(****************************************************************************)
procedure _OUTRegAN;
begin
inc(sp_reg.PC);
outDat(mem_b(sp_reg.PC),reg.A,reg.A);
inc(sp_reg.PC);
timer(11);
end;
(****************************************************************************)
procedure _OUTRegC(_dat:byte);
var _b:byte;
begin
_b:=_dat;
outDat(reg.C,reg.B,_b);
ChangeZS(_b);
ChangeP(_b);
Change35(_b);
inc(sp_reg.PC);
timer(12);
end;
(****************************************************************************)
procedure _OUTI;
begin
outDat(reg.C,reg.B,mem_b(reg_w.HL));
inc(reg_w.HL);
dec(reg.B);
ChangeZS(reg.B);
inc(sp_reg.PC);
timer(16);
end;
(****************************************************************************)
procedure _EI;
begin
MaskInt:=false;
inc(sp_reg.PC);
timer(4);
end;
(****************************************************************************)
procedure _DI;
begin
MaskInt:=true;
inc(sp_reg.PC);
timer(4);
end;
(****************************************************************************)
procedure _IMode(mode_num:byte);
begin
IM:=mode_num;
inc(sp_reg.PC);
timer(8);
end;
(****************************************************************************)
procedure _RetI;
begin
MaskInt:=false;
pop(sp_reg.PC);
timer(14);
end;
(****************************************************************************)
procedure _RetN;
begin
pop(sp_reg.PC);
timer(14);
end;
(****************************************************************************)
procedure _NOP;
begin
inc(sp_reg.PC);
timer(4);
end;
(****************************************************************************)
procedure _CPL;
begin
reg.A:=$FF-reg.A;
inc(sp_reg.PC);
timer(4);
end;
(****************************************************************************)
procedure _NEG;
var _sb:byte;
begin
_sb:=$00;
subRegN(_sb,reg.A);
reg.A:=_sb;
inc(sp_reg.PC);
timer(8);
end;
(****************************************************************************)
procedure _SCF;
begin
SetC;
inc(sp_reg.PC);
timer(4);
end;
(****************************************************************************)
procedure _CCF;
begin
if SetsC then ResetC else SetC;
inc(sp_reg.PC);
timer(4);
end;
(****************************************************************************)
procedure _HALT;
begin
SetC;
inc(sp_reg.PC);
NonHalt:=false;
repeat
timer(4);
until NonHalt;
end;
(****************************************************************************)
procedure _DAA;
var p,a:boolean;
begin
asm
pushf
pop bx
mov bl,reg.F
push bx
popf
mov al,reg.A
daa
mov reg.A,al
pushf
pop bx
mov reg.F,bl
end;
inc(sp_reg.PC);
timer(4);
end;
(****************************************************************************)
procedure _RLD;
var _c,_b,_m:byte;
begin
_b:=reg.A and $0F;
reg.A:=reg.A and $F0;
_m:=mem_b(reg_w.HL);
reg.A:=reg.A or (_m shr 4);
_m:=(_m shl 4)or _b;
write_b(reg_w.HL,_m);
if reg.A=0 then SetZ else resetZ;
setH;
ReSetC;
inc(sp_reg.PC);
timer(18);
end;
(****************************************************************************)
procedure _RRD;
var _b,_m:byte;
begin
_b:=reg.A and $0F;
reg.A:=reg.A and $F0;
_m:=mem_b(reg_w.HL);
reg.A:=reg.A or (_m and $0F);
_m:=(_m shr 4)or (_b shl 4);
write_b(reg_w.HL,_m);
if reg.A=0 then SetZ else resetZ;
ResetH;
SetC;
inc(sp_reg.PC);
timer(18);
end;
(****************************************************************************)
procedure TraceTo(addr_trace:word);assembler;
asm
cmp InitCode,true
jne @Start
 lea si,addrUntilCheck
 lea bx,@UntilCheck
 mov ds:[si],bx
 mov ds:[si+2],cs
 jmp @End
@Start:
 lea bx,@UntilCheck
  cmp PressExit,true;jnz @1
  mov ax,CodeJmpEndOp; mov cs:[bx],ax; jmp @00
 @1:
  cmp RunMode,true;jnz @2
  lea si,CodeJmpNextOp
  mov ax,ds:[si]; mov cs:[bx],ax;mov ax,ds:[si+2]; mov cs:[bx+2],ax; jmp @00
 @2:
  mov ax,CodeCmpDiAddrTrace; mov cs:[bx],ax
  lea bx,@cmpAddr_trace
  mov ax,addr_trace
  mov cs:[bx-1],ax
 @00:
 les di,memory
 mov di,sp_reg.PC
 cld
{| RDTSC}db $0F,$31
{| MOV [TICS],EAX}db $66;mov tics_w,ax
{| CLD}cld
{| 8 NOP}nop;nop;nop;nop;nop;nop;nop;nop
{|instuction to test >}

{repeat}
@NextOp:
mov al,es:[di]
cmp al,$80
jae @80toFF

jmp @_endDecode
@80toFF:

@_endDecode:

inc di
{SetRomType}
 cmp TheDosMode,true;jnz @NotDosMode
 cmp di,16384;jae @_SetSos{if di>=$4000}
 jmp far ptr @_endSetRom
@_SetSos:
 push ds;push di
 mov cx,$1000;les di,memory;lds si,sosRom
 db $66;rep movsw
 pop di;pop ds
 mov TheDosMode,false
 jmp far ptr @_endSetRom
@NotDosMode:
 cmp di,$3DFF;ja @_endSetRom
 cmp di,$3D00;jb @_endSetRom
 push ds;push di
 mov cx,$1000;les di,memory;lds si,dosRom
 db $66;rep movsw
 pop di;pop ds
 mov TheDosMode,true
@_endSetRom:
{until}
@UntilCheck:
 jmp near ptr @NextOp
 @cmpAddr_trace:db $00;jz @EndOp; jmp near ptr @NextOp
@EndOp:
{|end instruction to test}
{| CLC}clc
{| RDTSC}db $0F,$31
{| SUB EAX,[TICS]}db $66;sub ax,tics_w
{| SUB EAX,OverHead=16}db $66,$83,$E8,16
{| MOV [TICS],EAX}db $66;mov tics_w,ax
{|BreakPoint}nop
 mov sp_reg.PC,di
 mov pressExit,false
@End:
end;
(****************************************************************************)
(****************************************************************************)
(****************************************************************************)
function writeB(_dt:byte):string;
var s:string;
begin
s:=HX;
writeB:='$'+s[(_dt shr 4)+1]+s[(_dt and $0F)+1];
end;
function writeF(b:byte):string;
var s:string;
begin
s:='';
if (b and $80)=0 then s:=s+'s' else s:=s+'S';
if (b and $40)=0 then s:=s+'z' else s:=s+'Z';
if (b and $20)=0 then s:=s+'0' else s:=s+'1';
if (b and $10)=0 then s:=s+'h' else s:=s+'H';
if (b and $08)=0 then s:=s+'0' else s:=s+'1';
if (b and $04)=0 then s:=s+'v' else s:=s+'V';
if (b and $02)=0 then s:=s+'n' else s:=s+'N';
if (b and $01)=0 then s:=s+'c' else s:=s+'C';
writeF:=s;
end;
procedure Init;
begin
seg_world:=seg(EmulScreen^);
ofs_world:=ofs(EmulScreen^);
pressHelp:=false;
pressExit:=false;
RunMode:=false;
DebugMode:=false;
err_command:=false;
writeln('My Spectrum ...');
get_rom;
Quarz:=50{Hz};
MaxClock:=round(4e6/Quarz);{4}
set_interrupt;
set_keyboard;
NonMaskReady:=false;
IM:=1;
sp_reg.PC:=$0000;
end;
(****************************************************************************)
(****************************************************************************)
procedure closeGraph;
begin
 asm
 mov ax,$0003
 int $10
 end;
end;
(****************************************************************************)
procedure Done;
begin
reset_interrupt;
dispose(dosRom);
dispose(sosRom);
dispose(memory);
closeGraph;
end;
begin
InitCode:=true;
TraceTo(0);
InitCode:=false;
CodeJmpNextOp:=longint(addrUntilCheck^);
end.